\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{framedesk}[Frames Description Helper]

\RequirePackage{luacode}

\RequirePackage{ifmtarg}
\RequirePackage{etoolbox}
\RequirePackage{graphicx}

\RequirePackage{array}
\RequirePackage{longtable}
\RequirePackage{multirow}
\RequirePackage{makecell}

%---------------------------------------------------------------

\def\FrameDesc@INIT
{
  \luaexec
  {
    FrameDesc = {};
    FrameDesc.Pos = 
    {
      ["head"] = 'l',
      ["data"] = 'l',
      ["field"] = 'c', 
      ["fieldSize"] = 'c', 
      ["descVal"] = 'c', 
      ["descText"] = 'l'
    };
    FrameDesc.DataCount = 0;
    FrameDesc.Data = {};
  }

  \newcommand\head[1]
  % #1 - название
  {\luaexec{
    FrameDesc.DataCount = FrameDesc.DataCount + 1;
    FrameDesc.Data[FrameDesc.DataCount] = {};
    FrameDesc.Data[FrameDesc.DataCount].atr = 'Hbi';
    FrameDesc.Data[FrameDesc.DataCount].name = \luastring{##1};
    FrameDesc.Data[FrameDesc.DataCount].FieldCount = 0;
    FrameDesc.Data[FrameDesc.DataCount].Field = {};
  }}

  \newcommand\data[2][]
  % #1 - название
  {\luaexec{
    FrameDesc.DataCount = FrameDesc.DataCount + 1;
    FrameDesc.Data[FrameDesc.DataCount] = {};
    FrameDesc.Data[FrameDesc.DataCount].atr = \luastring{##1};
    FrameDesc.Data[FrameDesc.DataCount].name = \luastring{##2};
    FrameDesc.Data[FrameDesc.DataCount].FieldCount = 0;
    FrameDesc.Data[FrameDesc.DataCount].Field = {};
  }}

  \newcommand\field[2][]
  % #1 - название
  % #2 - размер
  {\luaexec{
    FrameDesc.Data[FrameDesc.DataCount].FieldCount = FrameDesc.Data[FrameDesc.DataCount].FieldCount + 1;
    FrameDesc.Data[FrameDesc.DataCount].Field[FrameDesc.Data[FrameDesc.DataCount].FieldCount] = {};
    FrameDesc.Data[FrameDesc.DataCount].Field[FrameDesc.Data[FrameDesc.DataCount].FieldCount].name =       \luastring{##1};
    FrameDesc.Data[FrameDesc.DataCount].Field[FrameDesc.Data[FrameDesc.DataCount].FieldCount].size =       \luastring{##2};
    FrameDesc.Data[FrameDesc.DataCount].Field[FrameDesc.Data[FrameDesc.DataCount].FieldCount].DescCount = 0;
    FrameDesc.Data[FrameDesc.DataCount].Field[FrameDesc.Data[FrameDesc.DataCount].FieldCount].desc = {};
  }}
  \newcommand\desc[2][]
  % #1 - значение
  % #2 - описание
  {\luaexec{
    FrameDesc.Data[FrameDesc.DataCount].Field[FrameDesc.Data[FrameDesc.DataCount].FieldCount].DescCount = FrameDesc.Data[FrameDesc.DataCount].Field[FrameDesc.Data[FrameDesc.DataCount].FieldCount].DescCount + 1;
    FrameDesc.Data[FrameDesc.DataCount].Field[FrameDesc.Data[FrameDesc.DataCount].FieldCount].desc[FrameDesc.Data[FrameDesc.DataCount].Field[FrameDesc.Data[FrameDesc.DataCount].FieldCount].DescCount] = {};
    FrameDesc.Data[FrameDesc.DataCount].Field[FrameDesc.Data[FrameDesc.DataCount].FieldCount].desc[FrameDesc.Data[FrameDesc.DataCount].Field[FrameDesc.Data[FrameDesc.DataCount].FieldCount].DescCount].val = \luastring{##1};
    FrameDesc.Data[FrameDesc.DataCount].Field[FrameDesc.Data[FrameDesc.DataCount].FieldCount].desc[FrameDesc.Data[FrameDesc.DataCount].Field[FrameDesc.Data[FrameDesc.DataCount].FieldCount].DescCount].text = \luastring{##2};
  }}
}

\newcommand\FrameDesc@make
{\luaexec{
  function FrameDesc.print(text)
    if 0 then texio.write_nl(text); end    
    tex.print(text);
  end
  for dK,dV in pairs(FrameDesc.Data) do
    dV.rowCount = 0;
    for fK, fV in pairs(dV.Field) do
      for dsK, dsV in pairs(fV.desc) do
        dV.rowCount = dV.rowCount + 1;
      end
    end
  end
  function cell_atr_proc(pos, atr)
    local b = ''; local e = '';
    if string.match(atr,'v') then
      b = b..'\\rotatebox[origin=c]{90}{';
      e = '}'..e;
    end
    if string.match(atr,'s') then
      b = b..'{\\footnotesize ';
      e = '}'..e;
    end
    if string.match(atr,'i') then
      b = b..'{\\itshape ';
      e = '}'..e;
    end
    if string.match(atr,'b') then
      b = b..'{\\bfseries ';
      e = '}'..e;
    end
    return b,e;
  end
  function cell(pos,val,atr)
    local b = ''; local e = '';
    b,e = cell_atr_proc(pos, atr);
    return b..'\\makecell[{{'..pos..'}}]{'..val..'}'..e;
  end
  function multicol(count, pos, val)
    if count > 1 then
      return '\\multicolumn{'..count..'}{'..pos..'}{'..val..'}';
    else
      return val;
    end
  end
  function multirowcell(count,pos,val,atr)
    res = cell(pos,val,atr);
    if count > 1 then
      res = '\\multirow{'..count..'}{*}{'..res..'}';
    end
    return res;
  end
  function strIsEmpty(str)
    return (str == nil) or (str == '');
  end
  local pos = 
  {
    ['h'] = FrameDesc.Pos.head,
    ['d'] = FrameDesc.Pos.data,
    ['f'] = FrameDesc.Pos.field,
    ['fs'] = FrameDesc.Pos.fieldSize,
    ['dev'] = FrameDesc.Pos.descVal,
    ['de'] = FrameDesc.Pos.descText
  };
  local posF = 
  {
    ['h'] = '|'..FrameDesc.Pos.head..'|',
    ['d'] = '|'..FrameDesc.Pos.data..'|',
    ['f'] = ''..FrameDesc.Pos.field..'|',
    ['fs'] = ''..FrameDesc.Pos.fieldSize..'|',
    ['dev'] = ''..FrameDesc.Pos.descVal..'|',
    ['de'] = ''..FrameDesc.Pos.descText..'|'
  };
  local row = ''; local line = '';
  local dummyrow =  '1 & 2 & 3 & 4 & 5 \\kill';
  FrameDesc.print(dummyrow);
  for dK,dV in pairs(FrameDesc.Data) do
    if string.match(dV.atr,'H') then
      line = '\\hline';
      row = multicol(5,posF.h,cell(pos.h,dV.name,dV.atr));
      FrameDesc.print(row..'\\\\'..line);
    else
      for fK, fV in pairs(dV.Field) do
        for dsK, dsV in pairs(fV.desc) do
          row = ''; line = '';
          if strIsEmpty(fV.name) then
            if (fK == 1)and(dsK == 1) then
              row = row..multicol(2,posF.d, multirowcell(dV.rowCount, pos.d,dV.name,dV.atr));
            else
              row = row..multicol(2,posF.d,'');
            end
          else
            if (fK == 1)and(dsK == 1) then
              row = row..multirowcell(dV.rowCount, pos.d,dV.name,dV.atr);
            end
            if dsK == 1 then
              row = row..' & '..multirowcell(fV.DescCount,pos.f,fV.name,'');
            else
              row = row..' & ';
            end
          end
          if dsK == 1 then
            row = row..' & '..multirowcell(fV.DescCount,pos.fs,fV.size,'');
          else
            row = row..' & ';
          end
          if strIsEmpty(dsV.val) then
            row = row..' & '..multicol(2,posF.de,cell(pos.de,dsV.text,''));
          else
            row = row..' & '..cell(pos.dev,dsV.val,'')..' & '..cell(pos.de,dsV.text,'');
          end
          if dsK == fV.DescCount then
            if (fK == dV.FieldCount) then
              line = '\\hline';
            elseif (fV.name == nil) or (fV.name == '') then
              line = '\\nopagebreak\\cline{3-5}';
            else
              line = '\\nopagebreak\\cline{2-5}';
            end
          else
            line = '\\nopagebreak\\cline{4-5}';
          end
          local fullrow = row..' \\\\'..line;
          FrameDesc.print(fullrow);
        end
      end
    end
  end
}}

\newcommand\FramneDesc@CmdForFastUsage@INIT
{
  \newcommand\FieldDesc[3][]
  {
    \field[##1]{##2}
    \desc{##3}
  }
  \newcommand\DataDesc[4][]
  {
    \data{##2}
    \field[##1]{##3}
    \desc{##4}
  }
}

\newcommand\FrameDescColPos[2]
{\luaexec{
    FrameDesc.Pos[\luastring{#1}] = \luastring{#2};
}}

\newcommand\FrameDesc@table@init
{
  \def\@cline##1-##2\@nil
  {
    \omit
    \@multicnt##1%
    \advance\@multispan\m@ne
    \ifnum\@multicnt=\@ne\@firstofone{&\omit}\fi
    \@multicnt##2%
    \advance\@multicnt-##1%
    \advance\@multispan\@ne
    \leaders\hrule\@height\arrayrulewidth\hfill
    \cr
    \noalign{\nobreak\vskip-\arrayrulewidth}
  }
}

\newcommand\FrameDesc@table@start
{\luaexec{
    local str = '\\begin{longtable}{|'..
      FrameDesc.Pos.data..'|'..
      FrameDesc.Pos.field..'|'..
      FrameDesc.Pos.fieldSize..'|'..
      FrameDesc.Pos.descVal..'|'..
      FrameDesc.Pos.descText..'|}'
    if 0 then texio.write_nl(str); end
    tex.sprint(str);
}}
\newcommand\FrameDesc@table@end{\end{longtable}}
%{\luaexec{
%    local str = '\\end{longtable}';
%    texio.write_nl(str);
%    tex.sprint(str);
%}}

\newcommand{\theFrameDescData}{Данные}
\newcommand{\theFrameDescFrameSize}{Размер}
\newcommand{\theFrameDescValue}{Значение}
\newcommand{\theFrameDescDesc}{Описание}

\newcommand\theFrameDescTableHead
{
  \multicolumn{2}{|c|}{\thead{\theFrameDescData}} &
  {\thead{\theFrameDescFrameSize}} & 
  %{\thead{\theFrameDescValue}} & 
  \multicolumn{2}{c|}{\thead{\theFrameDescValue\ / \theFrameDescDesc}}
}
\newcommand\theFrameDescTableHeadContinue{(продолжение)}

\newcommand\FrameDesc@table@header
{
  \caption{\label{\FrameDesc@Label}\FrameDesc@Name}\tabularnewline
  \hline \theFrameDescTableHead \endfirsthead
  \caption{\FrameDesc@Name\ \theFrameDescTableHeadContinue}\tabularnewline
  \hline \theFrameDescTableHead \endhead
  %\hline \endfoot
}

\newenvironment{FrameDesc}[2]
{
  \begingroup
  \FrameDesc@INIT
  \FramneDesc@CmdForFastUsage@INIT
  %
  \newcommand{\FrameDesc@Name}{#2}
  \newcommand{\FrameDesc@Label}{#1}
}
{
  \FrameDesc@table@init
  \FrameDesc@table@start
    \FrameDesc@table@header
    \hline
    \FrameDesc@make
  \FrameDesc@table@end
  \endgroup
}

%---------------------------------------------------------------
